\chapter{\CDCL-style SAT solving}\label{ch:cdcl}

One of the most basic logics is \emph{propositional logic}.
It exclusively deals with Boolean variables (sometimes called atomic propositions or propositional variables) and Boolean combinations thereof.
While the formal syntax is one of the simplest available, it already proves to be very powerful: the satisfiability problem for propositional logic is one of the original NP-complete problems from~\cite{Karp1972}.

\begin{definition}{Propositional logic}{propositional-logic}\silentdefindex{logic:propositional}
	Let $\mathcal{B}$ be the set of Boolean variables and $\B = \{ \false, \true \}$ the Boolean constants.
	The syntax of a \emph{propositional logic} formula $\varphi$ is defined as follows.
	\begin{align*}
		\varphi & \Coloneqq b \mid c & b \in \mathcal{B}, c \in \B \\
		\varphi & \Coloneqq \varphi \lor \varphi \mid \neg \varphi
	\end{align*}
	We assume that $\neg$ and $\lor$ have the common semantics of negation and conjunction.
	Further Boolean connectives, like disjunction or exclusive or, can be defined in terms of negation and conjunction as syntactic sugar.
\end{definition}

Note that we do not allow for explicit quantification of variables -- like for example \emph{quantified Boolean formulae} (QBF) does -- but rather push the quantification to the question we ask about the formula at hand.
Given a propositional logic formula $\varphi(\overline{x})$, we aim to decide whether it is satisfiable -- $\Exists{\overline{x}} \varphi(\overline{x})$ -- and reuse this to decide whether it is a tautology -- $\Forall{\overline{x}} \varphi(\overline{x}) \equiv \neg \Exists{\overline{x}} \neg\varphi(\overline{x})$.

\begin{definition}{Propositional satisfiability problem}{propositional-satisfiability}\silentindex{satisfiability}
	Let $\varphi$ be a propositional logic formula over variables $\overline{x}$.
	The \emph{propositional satisfiability problem} (SAT) is to decide whether there is a variable assignment for $\overline{x}$ that satisfies $\varphi$, or more formally, whether the following statement is true:
	\[
		\Exists{\overline{x}} \varphi(\overline{x})
	\]
\end{definition}

Practical algorithmic approaches to this problem usually follow one of two paths that we identify as \emph{enumeration} or \emph{deduction}.
The former works on the variable assignment and exploits that the number of variable assignments is finite, as the number of variables and the number of possible values for each variable is finite.
Given this finiteness, we can simply try all possible assignments and eventually find a satisfying one or find that there is none.
The latter uses logical reasoning on the formula to derive new knowledge about the solution space, aiming for a proof that there is no solution.

\section{Satisfiability via enumeration}

\silentdefindex{enumeration}
The arguably simplest approach to determine satisfiability is to try all possible assignments and check whether any of them satisfies the formula.
A naive implementation of this idea is shown in \cref{algo:enumeration}.
Assuming $n$ variables with two possible values each -- \true and \false{} -- we obtain at most $2^n$ variable assignments that we have to check as we can determine satisfiability as soon as one assignment is satisfying.

\begin{algorithm}[H]
	\caption{Solving the SAT problem via enumeration}\label{algo:enumeration}

	\SetKwFunction{Satisfiable}{Satisfiable}
	\Fn{\Satisfiable{$\varphi$}}{
		\For{every model $\alpha \in \A$}{
			\If{$\varphi(\alpha)$}{
				\Return{$SAT$} \;
			}
		}
		\Return{$UNSAT$}
	}
\end{algorithm}

We observe that the formula is hardly used here, in particular, we do not even attempt to make use of certain structures a formula may have.
For example, if our formula has the form $\varphi = x_1 \lor \varphi'$, we could determine satisfiability by assigning $x_1 \mapsto \true$ and avoid looking at a -- possibly huge -- remaining formula $\varphi'$.
This idea of exploiting formula structure leads to the following recursive \cref{algo:enumeration-recursive}.

\begin{algorithm}[H]
	\caption{Solving the SAT problem via recursive enumeration}\label{algo:enumeration-recursive}

	\SetKwFunction{Satisfiable}{Satisfiable}
	\Fn{\Satisfiable{$\varphi$}}{
		$x \coloneqq $ select unassigned variable from $\varphi$ \;
		\For{$value \in \{ \true, \false \}$}{\label{algo:enumeration-recursive:value-selection}
			\If{\Satisfiable{$\varphi[x/value]$} = $SAT$}{
				\Return{$SAT$}
			}
		}
		\Return{$UNSAT$}
	}
\end{algorithm}

This version of enumeration essentially builds partial assignments one variable at a time and tries substituting all possible values (\true and \false) for some variable.
The substitution allows to simplify the formula before extending the partial assignment and thereby could solve the above example $x_1 \lor \varphi'$ immediately -- given that we select $x_1$ and assign it to \true.

There are a few fundamental ideas that are already part of this very simple algorithm. Firstly, we try to make use of the structure of the formula at hand.
Secondly, we reduce our problem to one or more simpler problems and inherit or combine the results.
We see that even if we have no idea how to do a reduction, we can split into multiple cases -- this is what we do in \cref{algo:enumeration-recursive:value-selection} of \cref{algo:enumeration-recursive} -- and combine the results of all possible cases afterward. 
Thirdly, we have choices to make, for example, which variable to select or in which order to process our cases.


\section{Satisfiability via deduction}\label{ssec:cdcl:deduction}

\silentdefindex{deduction}
Given the nature of enumeration, it is only suited for questions of satisfiability and can not be applied for more complex questions, for example, variable elimination.
Deduction is a general approach that aims at inferring new facts that are implied by the current formula.
If we apply a (sound) deductive proof system, we construct a proof for such a new fact from our formula.
We usually try to infer \false, which proves unsatisfiability.

The most prominent example of such a deductive proof system is the (Boolean) \emph{resolution proof system}.
Though it only consists of a single rule -- which is sometimes argued to be a \emph{template} that can be instantiated to form arbitrarily many rules -- it is a sound and complete proof system for propositional logic.

\begin{definition}{Resolution proof system}{resolution-proof-system}\silentdefindex{resolution-proof-system}\silentdefindex{proof-system:resolution}
	Assume two clauses that share some variable $y$, though with opposite polarity.
	The \defindex{resolution-rule} states that
	\begin{align*}
		\ProofRule{Resolution}{(x_1 \lor \dots \lor x_i \lor y), (\neg y \lor z_1 \lor \dots \lor z_j)}{(x_1 \lor \dots \lor x_i \lor z_1 \lor \dots \lor z_j)}{}
	\end{align*}
	We say that we \emph{perform resolution on $y$} and write $Resolution_y(\cdot, \cdot)$, sometimes skipping the variable we perform resolution on.
	The \emph{resolution proof system} consists of only the \rulename{Resolution} rule.
\end{definition}

\begin{theorem}{Soundness \& completeness}{resolution}\silentindex{proof-system:soundness}\silentindex{proof-system:completeness}
	The resolution proof system, as defined in \cref{def:resolution-proof-system}, is \emph{sound} and \emph{refutationally complete} for propositional logic.
\end{theorem}

\begin{proof}[Soundness]
	Let $\varphi = (x_1 \lor \dots \lor x_i \lor y) \land (\neg y \lor z_1 \lor \dots \lor z_j)$ and $\alpha \in \mathcal{A}$ such that $\alpha \models \varphi$.
	Thus, $\alpha \models (x_1 \lor \dots \lor x_i \lor y)$ and $\alpha \models (\neg y \lor z_1 \lor \dots \lor z_j)$.
	We consider two cases: $\alpha \models y$ and $\alpha \models \neg y$.
	
	If $\alpha \models y$ we can infer $\alpha \models (z_1 \lor \dots \lor z_j)$ and thus $\alpha \models (x_1 \lor \dots \lor x_i \lor z_1 \lor \dots \lor z_j)$.
	In the same way, if $\alpha \models \neg y$ we can infer $\alpha \models (x_1 \lor \dots \lor x_i)$ and thus $\alpha \models (x_1 \lor \dots \lor x_i \lor z_1 \lor \dots \lor z_j)$.
	Hence, we get $\alpha \models (x_1 \lor \dots \lor x_i \lor z_1 \lor \dots \lor z_j)$ in both cases, and thus $\varphi \models (x_1 \lor \dots \lor x_i \lor z_1 \lor \dots \lor z_j)$.
\end{proof}

To prepare our proof for (refutational) completeness, we give \cref{algo:resolution} that only uses the resolution rule to determine the satisfiability of a formula in CNF.
The main idea -- which seems to originate in~\cite{Davis1960} -- is to eliminate one variable after another and eventually obtain a formula without variables, either \true or \false.
It does so by selecting an arbitrary variable $x$ from $\varphi$ splitting the clauses in three parts: $\varphi_x$ that contains $x$, $\varphi_{\neg x}$ that contains $\neg x$, and the rest $\varphi_R$.
Note that no clause contains both $x$ and $\neg x$ as such clauses are trivial tautologies that we (implicitly) remove from $\varphi$.

\begin{algorithm}
	\caption{Solving the SAT problem via binary resolution}\label{algo:resolution}

	\SetKwFunction{Satisfiable}{Satisfiable}
	\Fn{\Satisfiable{$\varphi$}}{
		\For{$x$ a variable of $\varphi$}{
			$\varphi_x \coloneqq \{ c \in \varphi \mid x \in c \}$ \;
			$\varphi_{\neg x} \coloneqq \{ c \in \varphi \mid \neg x \in c \}$ \;
			$\varphi_R \coloneqq \varphi \setminus (\varphi_x \cup \varphi_{\neg x})$ \;
			$\varphi \coloneqq \varphi_R \cup \{ Resolution_x(c,c') \mid c \in \varphi_x, c' \in \varphi_{\neg x} \}$
		}
		\If{$\varphi \equiv \true$}{
			\Return{$SAT$}
		}\Else{
			\Return{$UNSAT$}
		}
	}
\end{algorithm}

\begin{proof}[Refutational completeness]
	We proved that \cref{algo:resolution} is sound for all CNF formulae.
	We observe that at the end of the loop, $\varphi$ does no longer contain $x$ as $\varphi_R$ did not contain $x$ in the first place and the clauses resulting from performing resolution on $x$ do neither.
	Therefore, $\varphi$ eventually contains no variables and we get either an empty set of clauses (\true) or the empty clause (\false).
\end{proof}

Note that \cref{algo:resolution} does not immediately provide us with a satisfying assignment.
We can, however, create a model based on the intermediate clause sets.
Starting with an (initially empty) partial model, we substitute the model into the intermediate clause sets and consider the clauses that now only contain the next variable $x$.

We observe that there are only two (syntactically) possible clauses $(x)$ and $(\neg x)$. If none are present, we choose any value for $x$. If a single one is present, we choose the appropriate value for $x$.
The case that both are present is impossible, as it implies the presence of $(\neg \alpha, x)$ and $(\neg \alpha, \neg x)$ (which evaluate to $(x)$ and $(\neg x)$), which would have allowed for the resolution with the result $(\neg \alpha)$, invalidating the partial model $\alpha$.

Unfortunately, the elimination of a single variable may incur a quadratic increase of clauses which may even grow in size.
Thus we may exhibit a doubly exponential time and space complexity.

\section{Davis--Putman procedure}

We have shown that Boolean resolution is an effective technique for working on propositional formulae on its own, though with limited efficiency.
It is oftentimes only used as one of the ingredients, already~\cite{Davis1960} is actually concerned with deciding the satisfiability of \emph{first-order logic} formulae -- though with predicates without fixed semantics -- and proposes a method that roughly works as described below.

Firstly, the formula is transformed into what we now call \emph{Skolem normal form}: we introduce new function symbols and obtain a formula in \emph{prenex normal form} with only universal quantifiers and (implicitly) ask for the existence of the \emph{Skolem functions}.
Secondly, all (countably many) possibilities to \emph{ground} the formula are enumerated to instantiate the universally quantified variables.
Finally, after every instantiation, we check for the satisfiability of the conjunction of all the ground formulae.
If we eventually find one of the formulae to be unsatisfiable, this implies the unsatisfiability of the original formula.

For our purpose, we focus on the last step only that solves the satisfiability problem for propositional logic.
Three rules are proposed in~\cite[Section 4]{Davis1960} that are applied in a specific order and eventually derive either the empty clause or the empty formula, yielding $unsat$ or $sat$.

\begin{definition}{Davis--Putnam procedure for propositional logic}{dp-procedure}\silentdefindex{dp-procedure}
	Let $\varphi$ be a propositional formula in CNF.
	We define three rules that we call \rulename{One-literal} rule, \rulename{Affirmative} rule and \rulename{Elimination} rule.
	\vspace*{-2ex}
	\begin{align*}
		\intertext{The \rulename{One-literal} rule comes in three flavors, all aimed at eliminating variables that occur in clauses that only have a single literal.}
		\shortintertext{\textrm{\textbf{\rulename{One-literal:}}}}
		\inferrule{(x), (\neg x), \varphi}{\false} \qquad
		\inferrule{(x), \varphi}{\varphi[x/\true]} \qquad
		\inferrule{(\neg x), \varphi}{\varphi[x/\false]}
		\intertext{The \rulename{Affirmative} rule is aimed at eliminating variables, that only occur positively (or negatively) throughout the whole formula.}
		\shortintertext{\textrm{\textbf{\rulename{Affirmative:}}}}
		\inferrule{\varphi, \neg x \not\in \varphi}{\varphi[x/\true]} \qquad
		\inferrule{\varphi, x \not\in \varphi}{\varphi[x/\false]}
		\intertext{The \rulename{Elimination} rule is aimed at eliminating any variable by pairwise resolution, similar to \cref{algo:resolution}.
		Note that this rule technically uses non-CNF formulae, but can be implemented on clauses only easily.}
		\shortintertext{\textrm{\textbf{\rulename{Elimination:}}}}
		\inferrule{(\varphi_x \lor x) \land (\varphi_{\neg x} \lor \neg x) \land \varphi_R, x \not\in \varphi_R, \neg x \not\in \varphi_R}{(\varphi_x \lor \varphi_{\neg x}) \land \varphi_R}
	\end{align*}
	
	The algorithm presented in~\cite{Davis1960} employs these three rules as follows:

	\begin{algorithm}[H]
		\caption{Davis--Putnam procedure for propositional logic}\label{algo:dp-procedure}

		\SetKwFunction{Satisfiable}{Satisfiable}
		\Fn{\Satisfiable{$\varphi$}}{
			\While{\true}{
				\If{$\varphi \in \{ \true, \false \}$}{
					\Return{$\varphi$}
				}
				\If{\rulename{One-literal} rule is applicable on $\varphi$}{
					Apply \rulename{One-literal} rule to $\varphi$ \;
				}
				\ElseIf{\rulename{Affirmative} rule is applicable on $\varphi$}{
					Apply \rulename{Affirmative} rule to $\varphi$ \;
				}
				\Else{
					Select some variable $x$ from $\varphi$ \;
					Apply \rulename{Elimination} rule to $x$ in $\varphi$ \;
				}
			}
		}
	\end{algorithm}
\end{definition}

This method is interesting to us, as it can be seen as a first combination of the two paradigms of enumeration and deduction.
The \rulename{Elimination} rule implements the variable elimination idea that we have used in the purely deductive approach.
The other two rules also eliminate variables in a deductive fashion, but in a more constructive way that allows to immediately extend a (partial) model.

\section{Davis--Putnam--Logemann--Loveland procedure}

Shortly after~\cite{Davis1960} put forward a theoretical algorithm that they used to solve the problem manually, they described their experience with an actual software implementation in~\cite{Davis1962}.
Though most of this work is actually concerned with considerations concerning the hardware available at the time, it contains a single change to the abstract algorithm which proved to be groundbreaking.
Let us reconsider the \rulename{Elimination} rule from~\cite{Davis1960} which is used for eliminating a variable.
\begin{align*}
	\ProofRule{Elimination}{(\varphi_x \lor x) \land (\varphi_{\neg x} \lor \neg x) \land \varphi_R, x \not\in \varphi_R, \neg x \not\in \varphi_R}{(\varphi_x \lor \varphi_{\neg x}) \land \varphi_R}{}
\end{align*}
During implementation, the authors realized that this rule has an important catch.
Each clause from $\varphi_x$ (and $\varphi_{\neg x}$) has one literal less than its origin from $\varphi$, but when they get combined in $\varphi_x \lor \varphi_{\neg x}$ the clauses tend to grow significantly in size.
This effect can be mitigated by replacing the \rulename{Elimination} rule by a new \rulename{Splitting} rule:
\begin{align*}
	\ProofRule{Splitting}{(\varphi_x \lor x) \land (\varphi_{\neg x} \lor \neg x) \land \varphi_R, x \not\in \varphi_R, \neg x \not\in \varphi_R}{(\varphi_x \land \varphi_R), (\varphi_{\neg x} \land \varphi_R)}{}
\end{align*}
This avoids the growth of clauses, indeed clauses will get smaller because the variable $x$ is removed.
However, it comes with the cost of yielding two sub-problems: $\varphi_x \land \varphi_R$ and $\varphi_{\neg x} \land \varphi_R$ that we have to check one after the other.
There is an additional benefit, though: the \rulename{Splitting} rule -- producing smaller clauses -- tends to allow significantly more applications of the \rulename{One-literal} rule compared to the \rulename{Elimination} rule.

\begin{algorithm}
	\caption{Davis--Putman--Logemann--Loveland procedure\label{algo:DPLL-procedure}}\silentdefindex{DPLL}
	\SetKwFunction{Satisfiable}{Satisfiable}
	\Fn{\Satisfiable{$\varphi$}}{
		\While{\true}{
			\If{$\varphi \in \{ \true, \false \}$}{
				\Return{$\varphi$}
			}
			\If{\rulename{One-literal} rule is applicable on $\varphi$}{
				Apply \rulename{One-literal} rule to $\varphi$ \;
			}
			\ElseIf{\rulename{Affirmative} rule is applicable on $\varphi$}{
				Apply \rulename{Affirmative} rule to $\varphi$ \;
			}
			\Else{
				Select some variable $x$ from $\varphi$ \;
				Apply \rulename{Splitting} rule and obtain $\varphi', \varphi''$ \;
				\If{$\neg$ \Satisfiable{$\varphi'$}}{
					\Return{\false}
				}
				\If{$\neg$ \Satisfiable{$\varphi''$}}{
					\Return{\false}
				}
				\Return{\true}
			}
		}
	}
\end{algorithm}

This is what we know as the original \emph{\DPLL algorithm} that is still the (conceptual) basis of most modern SAT solvers.
We observe that, conceptually, we only use the simplest forms of deductive reasoning here -- the \rulename{One-literal} rule and the \rulename{Affirmative} rule.
The \rulename{Splitting} rule can instead be seen as some kind of enumeration as it enumerates all possible values for the selected variable. In this sense, \cref{algo:DPLL-procedure} is one of the first effective combinations of deduction and enumeration.

\section{Towards modern \DPLL}

The above \cref{algo:DPLL-procedure} has since been improved and extended in various ways that are standard in most of today's solvers. We now review the most important innovations.

We observe that the original version stores new formulae $\varphi'$ and $\varphi''$ in memory whenever the \rulename{Splitting} rule is applied. Though they could replace the original formula $\varphi$, this still usually incurs a significant memory overhead, in particular, due to the recursive nature of this process.
We can instead maintain the splits -- and the results of the other rules -- separately without actually changing the representation of the formula.
We store them in what is commonly called a \emph{trail}, essentially a list of variable assignments, and consider the formula with respect to the trail.

All three rules from~\cite{Davis1962} essentially assign a value to a variable, though in a slightly different manner. The \rulename{One-literal} rule identifies a logical implication in the sense that the variable assignment is enforced by the formula at hand. The \rulename{Affirmative} rule identifies assignments that are sound in the sense that they are consistent with the formula. The number of models may reduce, though not to zero. In contrast, the \rulename{Splitting} rule is merely a guess and we may be forced to consider the other choice as well. Hence, we distinguish between two types of assignments that we call \emph{propagations} and \emph{decisions} as defined in \cref{def:DPLL-trail}.

\begin{definition}{\DPLL trail}{DPLL-trail}\silentdefindex{DPLL:trail}
	The \DPLL algorithm works on a what we call the \emph{trail}.
	A trail $M$ is a sequence of elements of one of the two forms:
	\begin{align*}
		L &&& \textrm{Boolean decision of literal $L$} \\
		C \rightarrow L &&& \textrm{Boolean implication of literal $L$ due to a clause $C$}
	\end{align*}
	We call $L$ a \emph{decision} and $C \rightarrow L$ a \emph{propagation}.
	We say that a literal $L$ is \emph{assigned to} \true (\false) if $L \in M$ ($\neg L \in M$), otherwise $L$ is \emph{unassigned}.
\end{definition}

The notion of considering the formula \emph{with respect to a trail} -- or the partial assignment represented by the trail -- changes how we apply the original \DPLL rules.
The \rulename{One-literal} rule only works on clauses with a single literal, but these only rarely exist if we do not change the formula. Instead, we consider the \rulename{Boolean constraint propagation} rule as given in \cref{def:DPLL:BCP-rule}.

\begin{definition}{Boolean constraint propagation}{DPLL:BCP-rule}\silentdefindex{BCP}
	Let $M$ be some \DPLL trail and $C = (L \lor L_1 \lor \dots \lor L_k)$ a clause.
	The \rulename{Boolean constraint propagation} rule infers a variable assignment as follows:
	\begin{align*}
		\ProofRule{Boolean constraint propagation}{M, C}{\Seq{M, C \rightarrow L}}{\textrm{$\neg L_i \in M$ for all $i = 1 \dots k$} \\ \textrm{$L,\neg L \not\in M$}}
	\end{align*}
	Given a trail $M$ and a set of clauses $\Clauses$ we define $\BCP$ to apply the above rule until \emph{no suitable clause $C \in \Clauses$} exists anymore.
	We extend $\BCP$ to check for \emph{conflicting clauses} -- whose literals all evaluate to \false{} -- and let it return \false if it ever finds such a conflicting clause and \true otherwise.
\end{definition}

The \rulename{Affirmative} rule proves to be rather expensive to be employed in practice.
In order to check whether it can be employed, we need to establish a \emph{global information} about the number of \emph{unsatisfied clauses} containing a certain literal.
Therefore it is usually not used in the core of modern \DPLL-based SAT solvers.
The \rulename{Splitting} rule creates what we called a \emph{decision} and is given in \cref{def:DPLL:decision-rule}.

\begin{definition}{Decision}{DPLL:decision-rule}\silentdefindex{DPLL:decision-rule}\silentdefindex{decision}
	Let $M$ be some \DPLL trail and $L$ a literal that is unassigned in $M$.
	The \rulename{Decision} rule decides upon a variable assignment as follows:
	\begin{align*}
		\ProofRule{Decision}{M}{\Seq{M, L}}{\textrm{$L,\neg L \not\in M$}}
	\end{align*}
	Given a trail $M$, we define $\Decide$ to apply the decision rule \emph{once} and return \true if possible. If the rule is not applicable -- because all literals are already assigned -- it returns \false.
\end{definition}

Now that we store the current partial assignment in a trail, and that parts of this assignment are only guesses, we need a way to \emph{undo assignments}. Note that this idea of undoing assignments is not fundamentally new: \cref{algo:DPLL-procedure} returns from checking the satisfiability of $\varphi'$ and continues to explore $\varphi''$ afterward.
We essentially only reformulate this process as an iterative procedure, compared to the recursive formulation of \cref{algo:DPLL-procedure}.

\begin{definition}{Backtracking}{DPLL:backtracking}\silentdefindex{DPLL:backtracking}\silentdefindex{backtracking}
	Let $M$ be some \DPLL trail and such that some clause is \emph{conflicting}, that means it evaluates to \false under $M$. Furthermore, let us \emph{tag decisions} with a Boolean flag, being \false by default. We define \emph{basic \DPLL backtracking} as follows:
	\begin{align*}
		\ProofRule{Backtracking}{\Seq{N_1, L_{\false}, N_2}, C = (L_1 \lor \dots \lor L_k)}{\Seq{N_1, \neg L_{\true}}}{\textrm{$\neg L_1, \dots, \neg L_k \in \Seq{N_1, L_{\false}, N_2}$} \\ \textrm{$L$ is the \emph{rightmost} decision} \\ \textrm{that is \emph{tagged} with \false}}
	\end{align*}
	We define the $\Backtrack$ method to apply the above rule and return \true if possible. Otherwise, that is if no such decision can be found and thus the conflict can not be resolved, it returns \false.
\end{definition}

The basic version of backtracking defined in \cref{def:DPLL:backtracking} exactly models the recursive exploration from \cref{algo:DPLL-procedure}: it simply records whether the opposite branch of the search has already been explored -- by default is has not -- and also checks it.

Note that we assume $\BCP$ to work in an \emph{exhaustive} manner. Thus, in any trail a decision is followed by \emph{all} propagations that are possible.
In particular, the last decision is always part of the reason for a conflict and changing this decision \emph{always} resolves this particular conflict. Of course, changing the decision can still lead to another conflict, possibly even given by the very same clause, but the list of propagations is different.

Given these reformulations of the \DPLL rules, and the specifications of $\BCP$, $\Decide$, and $\Backtrack$, we now give what we call the \emph{\DPLL algorithm} in \cref{algo:DPLL}.

\begin{algorithm}[H]
	\caption{\DPLL algorithm}\label{algo:DPLL}\silentdefindex{DPLL:algorithm}
	\SetKwFunction{Satisfiable}{Satisfiable}
	\Fn{\Satisfiable{$\varphi$}}{
		\While{\true}{
			\While{$\neg\BCP\texttt{()}$}{
				\If{$\neg\Backtrack\texttt{()}$}{
					\Return{\false}
				}
			}
			\If{$\neg\Decide\texttt{()}$}{
				\Return{\true}
			}
		}
	}
\end{algorithm}

\section{Conflict-driven clause learning\label{sec:cdcl}}

\silentdefindex{cdcl}
Many improvements to the \DPLL algorithm from \cref{algo:DPLL} have been proposed that we summarize under the term \emph{conflict-driven clause learning}, fully aware that clause learning is only one of the techniques we present. \emph{Conflict-driven clause learning} -- for short \CDCL{} -- is the common term used for ``modern \DPLL-style SAT solving'' that comprises all the other techniques and clause learning is arguably the most important of them.
A fundamental term for \CDCL is what we call a \emph{decision level}.

\begin{definition}{Decision level}{decision-level}\silentdefindex{decision-level}
	Let $M$ be some trail and $M_D$ the subsequence of $M$ consisting only of the decisions from $M$. We call $|M_D|$ the \emph{current decision level of $M$} and sometimes write $DL(M)$.

	Let $M_k$ be the longest prefix of $M$ that has decision level $k$.
	We say that some literal $L$ \emph{has decision level $k$} if $L \in M_k$ but $L \not\in M_{k-1}$, and \emph{something holds at decision level $k$} if it holds for $M_k$.
	We sometimes write $DL(L)$ and $DL(C)$ for the largest decision level of some literal from a clause $C$.
\end{definition}

\subsection{Clause learning}

\silentdefindex{cdcl:clause-learning}
We have seen in \cref{def:DPLL:backtracking} that having a clause evaluate to \false somehow implies the negation of the last decision, though the premise was somewhat vague.
Essentially, we have seen that a decision $L$ \emph{did not work out}, and thus -- under the assumptions represented by the preceding part of the trail -- either $\neg L$ is correct, or said preceding part of the trail was already incorrect.
\emph{Clause learning} aims to make this reasoning \emph{explicit} and \emph{persistent} so that it can be reused later on.

Assume a trail $\Seq{N_1, L, N_2}$ where $L$ is the rightmost decision and some clause $C$ is conflicting.
The goal is to construct a new clause $D$ that represents the logical implication $N_1 \implies \neg L$ from $C$ and the information contained in $N_2$.
Conceptually, we can understand the task as \emph{eliminating variables from $C$} such that only variables from $N_1$ remain.

\begin{algorithm}[H]
	\caption{Conflict resolution}\label{algo:cdcl:resolution}

	\SetKwFunction{ConflictResolution}{ConflictResolution}
	\Fn{\ConflictResolution{$M$, $C$}}{
		\While{$M \neq \Seq{}$}{
			$T \coloneqq removeLastFrom(M)$ \;
			\If{$T = E \rightarrow L$ and $\neg L \in C$}{
				$C \coloneqq \Resolution_L(C, E)$ \;
			}
			\If{$T = L$ and $\neg L \in C$}{
				break \;
			}
		}
		\Return{$C$} \;
	}
\end{algorithm}

The given \cref{algo:cdcl:resolution} achieves exactly what we described before: it works its way backward through the trail, eliminates literals from the conflict clause -- by using Boolean resolution -- until we find a decision literal whose negation is part of the clause.
It also already performs the backtracking, exactly as \cref{algo:DPLL} did.

Note that we usually generalize this method: instead of generating a clause that implies the negation of some decision we allow to learn \emph{any} clause that is conflicting on the current trail and implies \emph{some literal} after appropriate backtracking.
We would usually stop the resolution process in \cref{algo:cdcl:resolution} as soon as $C$ contains only a single literal from the \emph{last decision level}, thereby implying this single literal after we have backtracked the whole decision level.
We call such a clause \emph{asserting} and the first literal where the clause becomes asserting is called the \emph{first unique implication point}~\cite{Moskewicz2001}.

The backtracking checks whether the resulting clause is the empty clause, in which case it returns \false, or returns the clause for propagation.
We can go a step further and \emph{learn} the clause: we add it to the set of clauses $\Clauses$ and thus can use it for propagation at any point in the future.
Slightly varying schemes for clause learning have been introduced in~\cite{Silva1996} and~\cite{Bayardo1997}.

\begin{algorithm}[H]
	\caption{Backtracking with clause learning}\label{algo:cdcl:bt-with-clause-learning}

	\SetKwFunction{Backtrack}{Backtrack}
	\Fn{\Backtrack{$M$, $C$}}{
		$D \coloneqq \ConflictResolution{M, C}$ \;
		\If{$D \neq \false$}{
			$\Clauses \coloneqq \Clauses \cup \{ D \}$ \;
		}
		\Return{$D$} \;
	}
\end{algorithm}

\subsection{Non-chronological backtracking}

\silentdefindex{non-chronological-backtracking}\silentindex{cdcl:backtracking}
We observe that (intuitively) propagations are \emph{never harmful} because they only implement logical deductions that are sound. We never have to backtrack \emph{because of} a propagation, they may only show that a decision was wrong so that we have to backtrack \emph{because of that decision}.
Decisions, on the other hand, are hazardous: they are just guesses and a bad guess may induce any amount of pointless calculations.
This is already reflected to some degree in our algorithm, as we eagerly perform propagation exhaustively and only resort to decisions afterward.

When learning a new clause, like when using backtracking with clause learning, it might be the case that the new clause is already unit at an earlier point in the trail.

\begin{example}{Early propagation of learned clauses}{cdcl:non-chronological-backtracking}
	Let $\varphi = (\neg a \lor \neg c \lor d) \land (\neg c \lor \neg d) \land \varphi'$ where $\varphi'$ also contains a Boolean variable $b$.
	Assuming the trail $M = \Seq{a, b, c, (\neg a \lor \neg c \lor d) \rightarrow d}$, $\BCP$ finds the conflicting clause $C = (\neg c \lor \neg d)$.

	\cref{algo:cdcl:resolution} would now remove $(\neg a \lor \neg c \lor d) \rightarrow d$ from the trail and compute the new conflict clause $C \coloneqq (\neg a \lor \neg c)$. In the next step, it finds the decision $c$ with $\neg c \in C$ and, therefore, returns $C$ while the remaining trail is $M = \Seq{a,b}$.

	We observe that $C = (\neg a \lor \neg c)$ is now unit and $\BCP$ propagates $C \rightarrow \neg c$ in the next step. However, we could backtrack even further and -- relative to the search space exploration -- utilize the new propagation \emph{earlier}.
	In this case, we backtrack to $M = \Seq{a}$ and already then use $C$ to obtain $M = \Seq{a, C \rightarrow \neg c}$.
\end{example}

We can see in \cref{ex:cdcl:non-chronological-backtracking} that the clause that results from \cref{algo:cdcl:resolution} can be unit on a \emph{smaller decision level}. Hence, it seems reasonable to already use this propagation on a smaller decision level in the hope to change how the search proceeds (in a positive way). Of course, backtracking further undoes some work that we may just repeat, but experimental experience shows that this potentially redundant work is worth it.

It remains to determine \emph{which decision level to backtrack to}.
Given that we want to utilize the clause $C$ for propagation, $C$ must still be unit and thus all but one literal must be assigned. If we consider the set of decision levels of the literals of $C$, we observe that conflict literal $\neg L$ is the single literal at the highest decision level (say $l$).
Let now $k < l$ be the largest decision level present in $C$ except for $\neg L$.

As all literals from $C$ -- except for $\neg L$ -- have a decision level of at most $k$, $C$ is still unit at decision level $k$. While the above methods only backtrack to decision level $l-1$, we can thus also backtrack to decision level $k$ -- actually any decision level between $k$ and $l-1$.
This is what we call \emph{non-chronological backtracking}, first applied to satisfiability checking in~\cite{Silva1996}, and shown in \cref{algo:cdcl:non-chronological-backtracking}.

\begin{algorithm}[H]
	\caption{Non-chronological backtracking with clause learning}\label{algo:cdcl:non-chronological-backtracking}\silentdefindex{cdcl:backtracking}
	\SetKwFunction{Backtrack}{Backtrack}
	\Fn{\Backtrack{$M$, $C$}}{
		$C \coloneqq \ConflictResolution{M, C}$ \;
		\If{$C \neq \false$}{
			$\Clauses \coloneqq \Clauses \cup \{ C \}$ \;
		}
		Backtrack to $DL(C \setminus \{\neg L\})$ \;
		\Return{$C$} \;
	}
\end{algorithm}

\subsection{Watched literal scheme\label{ssec:cdcl:watched-literal}}

\silentdefindex{cdcl:watched-literal}
Boolean constraint propagation proves to be incredibly powerful in practice but heavily depends on the ability to perform it efficiently. In particular, it is not feasible -- for large formulae -- to linearly scan the set of clauses to check whether some clause is unit.
Instead, we need some way to quickly obtain a (small) set of clauses that \emph{might be unit}.

One technique that has significantly improved performance of this across the board is the \emph{two watched literal scheme} introduced in~\cite{Moskewicz2001}.
The fundamental idea is based on the following two observations:
a clause can only become unit if
\begin{enumerate*}
	\item it had (at least) two unassigned literals and
	\item one of these has then been assigned to \false.
\end{enumerate*}
Note that we conveniently ignore clauses with a single literal here.

Therefore, we \emph{watch} two literals from each clause and have a closer look at this specific clause only when one of these literals is assigned to \false.
In practice, we maintain a mapping from every literal to a set of clauses and put every clause in the list of \emph{two} of its literals.
Whenever we assign a literal $L$ (either by decision or propagation), we review the clauses from the \emph{watch list of $\neg L$}, distinguishing whether the other watched literal which is
\begin{enumerate*}
	\item unassigned,
	\item assigned to \true, or
	\item assigned to \false.
\end{enumerate*}

If the other watched literal is assigned to \true, the clause is satisfied and there is nothing to do.
If the other watched literal is not yet assigned or assigned to \false, the clause \emph{could} be unit.
We consider the remaining literals of this clause and move the watch if we find another literal that is either unassigned or assigned to \true.
If such a literal does not exist, all but the other watched literal are assigned to \false and the considered clause is either suitable for propagation (if the other watched literal is not yet assigned) or conflicting (if the other watched literal is assigned to \false).

We note that the actual implementation of this scheme is very technical and must be done in a way that is compatible with the backtracking in that the watches must end up in some consistent state after undoing assignments.
As this is highly specific to the actual implementation, we refer to~\cite{Moskewicz2001} for more details.


\subsection{Restarts and clause removal}\label{ssec:cdcl:restart}

\silentdefindex{cdcl:restarts}
Most of the above techniques aim to accumulate more and better clauses and make use of available clauses faster.
Practical experiments showed, however, that \emph{bad decisions} early on in the search sometimes lead to a particularly hard part of the search space.
Allowing the solver to \defindex{restart} -- clearing the trail, but retaining the learned clauses -- provides the opportunity to switch to another, easier part of the search space.

The idea to regularly restart the solver is usually attributed to~\cite{Gomes1998}, though it was combined with randomization of the solving process.
The concept of restarting the solver was then decoupled from randomization -- for example in~\cite{Moskewicz2001} -- and subsequently the frequency of restarts was made adaptive in~\cite{Een2003}. Note that performing restarts without randomization only makes sense if the \emph{variable ordering} -- that we discuss in the next section -- is dynamic. Otherwise, the solver simply replays the very same decisions and propagations after a restart.

Given that a clause is added to the clause database for every conflict, we might collect a large number of clauses that eventually slow down the solver.
Furthermore, many of these clauses may be redundant -- not only in the theoretical sense (because all learned clauses are redundant), but in the practical sense that we never use them again.

Assume that some part of the search space (say $\Seq{a \mapsto \false, b \mapsto \false}$) has been excluded (by $(a \lor b)$) but it required several intermediate conflicts to construct this clause, for example $(a \lor b \lor c)$, $(a \lor b \lor \neg c \lor d)$ and $(a \lor b \lor \neg c \lor \neg d)$.
We observe that the (smaller) clause $(a \lor b)$ is a much \emph{stronger} statement than the other clauses, and it might make sense to \emph{forget} the other (larger) clauses. Actual schemes how to determine which clauses to remove are discussed in~\cite{Moskewicz2001} or~\cite{Een2003}.

Regular restarts, in particular in conjunction with clause removal, have the potential to lead to nontermination. If all clauses that were learned since the last restart are removed -- and there is no reason why this is not possible in general -- we may only repeat the same reasoning over and over again without any progress that persists beyond the next restart.

The common solution is already mentioned in~\cite{Moskewicz2001}: the periodicity of restarts is increased over time so that the whole solving process eventually fits in between two consecutive restarts.
One variant that was proposed in~\cite{Huang2007} and has become very popular since is to use a \emph{Luby sequence}, which intuitively alternates frequent restarts and increasingly long periods without a restart.

\subsection{Decision and value heuristics}\label{ssec:cdcl:decision}

\silentdefindex{decision-heuristic}
The methods we have described give rise to several heuristic choices, most prominently the \emph{choice of a decision variable}, but also which polarity to decide for, when to restart, or which clauses to forget.

The importance of the heuristic for selecting the decision variable -- usually called \defindex{decision-heuristic} or \emph{branching heuristic} -- was recognized early on and many different approaches were presented.
Prominent examples are heuristics due to Böhm~\cite{Buro1992}, the \emph{MOM heuristic}~\cite{Freeman1995}, \emph{dynamic largest individual sum}~\cite{Silva1996}, or \emph{Jeroslow-Wang}~\cite{Jeroslow1990}. All of them fall in one of two classes: they are either \emph{static} -- computed once at the beginning -- or \emph{dynamic} -- computed for every decision. While the static ones are very fast, the dynamic ones tend to make better decisions.

Eventually, a class of heuristics that we call \emph{quasi-static} was proposed that is both adaptive and very fast when making a decision.
First presented in~\cite{Moskewicz2001} and subsequently improved in~\cite{Een2003}, we call them (exponential) \emph{variable state independent decaying sum} (VSIDS).
VSIDS maintains an \emph{activity} for every variable that is \emph{increased} when this variable is part of a conflict and decays over time, such that recent conflict have a higher weight than older conflicts.

Though it may seem counter-intuitive to aim for conflicts -- instead of satisfying assignments -- the practical performance of VSIDS is sufficiently convincing so that essentially all state-of-the-art solvers employ some variant of VSIDS nowadays. 
Nonetheless, improvements are still developed, for example in~\cite{Liang2015} or~\cite{Liang2016}, mostly trying to exploit structural properties of the formula (like the ``community structure'') or operational properties of the solver (like ``global learning rate'').